
// simple.cpp;

/*----------------------------------------------------------------*\
  
   Introduction To Windows Programming       Author: Kurt Miller

   This is the sample source code that accompanies the tutorial.
   This code was tested with Visual C++ 6.0 only.     
                                                        12/12/98

\*----------------------------------------------------------------*/


#include <windows.h>

 
#define WIN32_LEAN_AND_MEAN   // Quicker build times;

#define WINDOWNAME "Simple Sample Application"



/*----------------------------------------------------------------*\
   Global Variables - to vanish in the C++ version;
\*----------------------------------------------------------------*/

      HWND hWnd;       // Main window handle;





/*----------------------------------------------------------------*\
   Function: WindowProc();
   Purpose:  Handles window messages;
\*----------------------------------------------------------------*/

LRESULT CALLBACK WindowProcedure(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam) {

      switch(msg) {

            case WM_MOVE:

                 MessageBox(hWnd, "WM_MOVE: The Window Moved", WINDOWNAME, MB_OK);
                 return 0;

            case WM_DESTROY:

                 MessageBox(hWnd, "WM_DESTROY: Exiting Application", "Goodbye!", MB_OK);
                 PostQuitMessage(0);    
                 
                 return 0;
	}

      return DefWindowProc(hWnd, msg, wParam, lParam);
}




/*----------------------------------------------------------------*\
   Function: WinMain();
   Purpose:  Program initial entry point;
\*----------------------------------------------------------------*/

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrev, LPSTR lpCmdLine, int Cmd) {

      MSG msg;

// Setup and register the window class; 

      WNDCLASS wClass;
               wClass.style         =CS_HREDRAW|CS_VREDRAW;
               wClass.lpfnWndProc   =WindowProcedure;  // callback-function;
               wClass.cbClsExtra    =0;
               wClass.cbWndExtra    =0;
               wClass.hInstance     =hInstance;
               wClass.hIcon         =LoadIcon(hInstance,IDI_APPLICATION);
               wClass.hCursor       =LoadCursor(NULL,IDC_ARROW);
               wClass.hbrBackground =(HBRUSH)(COLOR_WINDOW+3);
               wClass.lpszMenuName  =NULL;
               wClass.lpszClassName =WINDOWNAME;
  
      RegisterClass(&wClass);


      // Create the window and store the handle;

            hWnd = CreateWindow(WINDOWNAME,                    // class name;
                                WINDOWNAME,                    // window name;
                                WS_OVERLAPPEDWINDOW,           // window style;
                                CW_USEDEFAULT, CW_USEDEFAULT,  // starting position (x,y);
                                320, 240,                      // width and height;
                                NULL,                          // parent handle;
                                NULL,                          // menu handle;
                                hInstance,                     // instance handle;
                                NULL);                         // other parameters;
	      

      // Check if window creation failed; otherwise show and update;

            if(hWnd==NULL) return FALSE; 
            else {

	            ShowWindow  (hWnd, Cmd);
                  UpdateWindow(hWnd);

            }


      // Message loop;

      while(GetMessage(&msg,NULL,0,0)) {
            TranslateMessage(&msg);
            DispatchMessage (&msg);
      }

      return msg.wParam;
}

